hdu 3333 树状数组+离线处理

http://acm.hdu.edu.cn/showproblem.php?pid=3333

不错的题,想了很久不知道怎么处理,而且答案没看懂,然后找个例子模拟下别人的代码马上懂了---以后看不懂的话就拿个例子模拟下别人的代码

举个例子:1 3 3 5 3 5

查询

a, 2 4

b, 2 5

最初是这么想的:对于a查询,倘若把第二个数第三个数变成1个3,那么到b查询,又出现了两个3,再做处理似乎还是O(n),而且如果先出现2,5查询,后出现2,4查询,那么还需要把删除的数补回来.....o(╯□╰)o,然后就陷入迷茫啊.......

题解:

1、把查询按区间右端点由小到大排列,就避免了“需要把删除的数补回来”,如上面的例子,a查询的时候删除的3,在b查询的时候仍需要删除,但是如果先b查询后a查询,b查询需要删除第二个数第三个数,a查询需要把第三个数补回来....

2、每查询到一个区间,确保以右端点为结束为止的前缀没有重复的数

具体看代码-----拿例子模拟下,,回头我一定重写一遍

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <string>
#include <iostream>
#include <cmath>
#include <map>
#include <set>
#include <queue>
using namespace std;

#define ls(rt) rt*2
#define rs(rt) rt*2+1
#define ll long long
#define ull unsigned long long
#define rep(i,s,e) for(int i=s;i<e;i++)
#define repe(i,s,e) for(int i=s;i<=e;i++)
#define CL(a,b) memset(a,b,sizeof(a))
#define IN(s) freopen(s,"r",stdin)
#define OUT(s) freopen(s,"w",stdout)

const int MAXN =  50000+100;
struct Query
{
    int l,r;
    int id;
    bool operator < (const Query &c)const
    {
        return r<c.r;
    }
}q[100000 + 100];

ll c[MAXN],ans[100000 + 100];
ll num[MAXN],bi[MAXN];
int last[MAXN];
int N;

inline int lowbit(int i){return i&(-i);}

void add(int x, int v)
{
    while(x<=N)
    {
        c[x]+=v;
        x+=lowbit(x);
    }
}
ll sum(int i)
{
    ll ret=0;
    while(i>0)
    {
        ret+=c[i];
        i-=lowbit(i);
    }
    return ret;
}

int main()
{
    //IN("hdu3333.txt");
    int ncase,Q;
    scanf("%d",&ncase);
    while(ncase--)
    {
        CL(c,0);CL(last,0);
        scanf("%d",&N);
        for(int i=1;i<=N;i++)
        {
            scanf("%I64d",&num[i]);
            bi[i]=num[i];
        }

        scanf("%d",&Q);
        for(int i=1;i<=Q;i++)
        {
            scanf("%d%d",&q[i].l,&q[i].r);
            q[i].id=i;
        }
        sort(q+1,q+1+Q);
        sort(bi+1,bi+1+N);
        int qu=1;
        for(int i=1;i<=N;i++)
        {
            int pos=lower_bound(bi+1,bi+1+N,num[i])-bi;
            if(!last[pos])
            {
                add(i,num[i]);
                last[pos]=i;
            }
            else
            {
                add(last[pos],-num[i]);
                add(i,num[i]);
                last[pos]=i;
            }
            while(q[qu].r == i && qu<=Q)
            {
                ans[q[qu].id]=sum(i)-sum(q[qu].l-1);
                qu++;
            }
        }
        for(int i=1;i<=Q;i++)
            printf("%I64d\n",ans[i]);
    }
    return 0;
}

hdu 3333 树状数组+离线处理,布布扣,bubuko.com

时间: 2024-12-21 14:34:36

hdu 3333 树状数组+离线处理的相关文章

hdu 4368 树状数组 离线维护

http://acm.hdu.edu.cn/showproblem.php?pid=4638 Problem Description There are n men ,every man has an ID(1..n).their ID is unique. Whose ID is i and i-1 are friends, Whose ID is i and i+1 are friends. These n men stand in line. Now we select an interv

hdu 3333(树状数组 + 离散化 + hash)

Turing Tree Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 3847    Accepted Submission(s): 1306 Problem Description After inventing Turing Tree, 3xian always felt boring when solving problems a

hdu 3874 树状数组+离线处理

题意: 这和hdu 3333 根本就是一道题   链接:http://blog.csdn.net/u013382399/article/details/45689977 思路: 同hdu 3333 code: #include<cstdio> #include<iostream> #include<cstring> #include<algorithm> #include<vector> #include<string> #inclu

Turing Tree HDU - 3333 (树状数组,离线求区间元素种类数)

After inventing Turing Tree, 3xian always felt boring when solving problems about intervals, because Turing Tree could easily have the solution. As well, wily 3xian made lots of new problems about intervals. So, today, this sick thing happens again..

HDU 3333 Turing Tree 树状数组 离线查询

题意: 给你一个数列,然后有n个查询,问你给定区间中不同数字的和是多少. 思路还是比较难想的,起码对于蒟蒻我来说. 将区间按照先右端点,后左端点从小到大排序之后,对于每个查询,我只要维护每个数字出现的最后一次就可以了(这个结论稍微想一下就可以证明是正确的). 然后就是简单的点更新,区间求和问题了- #include <cstdio> #include <cstring> #include <iostream> #include <map> #include

HDU 3333 Turing Tree(树状数组离线处理)

HDU 3333 Turing Tree 题目链接 题意:给定一个数组,每次询问一个区间,求出这个区间不同数字的和 思路:树状数组离线处理,把询问按右端点判序,然后用一个map记录下每个数字最右出现的位置,因为一个数字在最右边出现,左边那些数字等于没用了,利用树状数组进行单点修改区间查询即可 代码: #include <cstdio> #include <cstring> #include <algorithm> #include <map> using n

HDU 4417 Super Mario ( 超级马里奥 + 主席树 + 线段树/树状数组离线处理 + 划分树 )

HDU 4417 - Super Mario ( 主席树 + 线段树/树状数组离线处理 + 划分树 ) 这道题有很多种做法,我先学习的是主席树.后面陆续补上线段树离线和划分树 题目大意就是给定一个区间给定一个数列,每次要求你查询区间[L,R]内不超过K的数的数量 主席树做法: 最基本的是静态第k大,这里是求静态的 <= K,差不多,在Query操作里面需要修改修改 先建立size棵主席树,然后询问的时候统计的是 第R棵主席树中[1,K]的数量 - 第L-1棵主席树中[1,K]的数量 注意这里下标

Necklace HDU - 3874 (线段树/树状数组 + 离线处理)

Necklace HDU - 3874 Mery has a beautiful necklace. The necklace is made up of N magic balls. Each ball has a beautiful value. The balls with the same beautiful value look the same, so if two or more balls have the same beautiful value, we just count

Hdu 3887树状数组+模拟栈

题目链接 Counting Offspring Time Limit: 15000/5000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)Total Submission(s): 1757    Accepted Submission(s): 582 Problem Description You are given a tree, it’s root is p, and the node is numbered fr